
#include "BlockMgr.h"
using namespace std;

bool UsageBlockPath::operator()(Block b1, Block b2)
{
    if(b1.blockModul()==b2.blockModul())
    {
    if(b1.hopBlock()==b2.hopBlock()) //dla takiej samej modulacji i takiej samej liczbie skokow
    {
if(b1.numFreeB()== b2.numFreeB() )//gdy zuzyja tyle samo nowych slotow
        {
    if(b1.usageB() == b2.usageB())//wykorzystanie blokow jest takie samo
    {
        if (b1.sizeB()==b2.sizeB())
                {
                    return b1.idx() < b2.idx(); //to w kolejnosci indeksow startu
                }
                return b1.sizeB()<b2.sizeB();
            }
        return b1.usageB() > b2.usageB(); //zwroc od najwikszego usage
    }
    return b1.numFreeB()< b2.numFreeB();
    }
   return b1.hopBlock()<b2.hopBlock();
    }
    return b1.blockModul()<b1.blockModul();
}


BlockMgr::BlockMgr(){}




void BlockMgr::addMaxUsageBlockFromSet(BlockSet bs)
{
    bs.orderByUsage();
    int start=bs.sortByUsage();
    int size=bs.getBlockSize(0);
    cout<< " dodany blok ";
    bs.getBlock(0).displayBlock();

    m_blockMgr.push_back(bs.getBlock(0));

}
void BlockMgr::addHeadFitFromSet(BlockSet bs) //nie ma sensu dodawac po kilka blokow ze sciezki, bo skoro jest najleopsze dla jednej sciezki to inne sa gorsze
{
    bs.orderByHeadFit();
    /*int start=bs.sortByUsage();
    int size=bs.getBlockSize(0);*/
    bs.getBlock(0).displayBlock();

    m_blockMgr.push_back(bs.getBlock(0));

}


void BlockMgr::sortCanByUsage()
{
     sort(m_blockMgr.begin(), m_blockMgr.begin()+m_blockMgr.size(), UsageBlockPath());
}
int BlockMgr::getStartBlockMgr(int idx)
{
    sort(m_blockMgr.begin(), m_blockMgr.begin()+m_blockMgr.size(), UsageBlockPath());
    return m_blockMgr[idx].idx();
}

 vector<bool>BlockMgr::pathMaxUsageBlock()// indeks najlepszego dopasowania wszystkich blokow candydujacych sciezek ,rozwaania zbioru tej samej modulacji , jak lepsze dopasowanie w wiekszej modulacji to wybieramy dla mniejszej
{
     sort(m_blockMgr.begin(), m_blockMgr.begin()+m_blockMgr.size(), UsageBlockPath());
     cout<< "m_blockMgr[0]path "<<endl;
     return m_blockMgr[0].blockPath();
 }
 int BlockMgr::getModulBlockMgr( int idx)
 {
     return m_blockMgr[idx].blockModul();
     }



void BlockMgr::displayMgr()
{
    for(int i=0; i<m_blockMgr.size();++i)
    {
        cout <<  i << " ";
        m_blockMgr[i].displayBlock();
    }
}
int BlockMgr:: sizeMgr()
{
    return m_blockMgr.size();
}

BlockMgr::~BlockMgr(){}

