
#ifndef _BLOCKMGR_H_
#define _BLOCKMGR_H_
#include "glNaglowek.h"
#include "BlockSet.h"

//sortowanie blokow sciezki po iloisci nowo uzytych slotow w sieci, a nastepnie po ich wykorzystaniu
class UsageBlockPath{
public:
    bool operator()(Block b1, Block b2);//porwnanie blokow nalezacych do roznych sciezek i bedacych dla swoich sciezek maxUsage
                                        //pod wzgledem numFree, maxUsage a nasteopnie po rozmiarze tych blokow maxUsage
};

class BlockMgr
{
public:

    vector<Block> m_blockMgr;//wektor blokow od roznych sciezek
    BlockMgr();

    void addMaxUsageBlockFromSet(BlockSet bs);
    void addHeadFitFromSet(BlockSet bs);

    void addBlocks(vector<bool> pathSD, int numReq, vector<int> sumF, int modul);


int numReqMgr(int idx);
void sortCanByUsage();//sortowanie elemntow
int getStartBlockMgr(int idx);
vector<bool> pathMaxUsageBlock();//sciezka, dla ktorej znaleziono , blok o najwiekszym wykorzystaniu slotow w sieci
int getModulBlockMgr( int idx);

void displayMgr();
int sizeMgr();
virtual ~BlockMgr();
};



#endif


