/*
 * SetMgr.cc
 *
 *  Created on: 20-10-2014
 *      Author: Edyta
 */

#include "SetMgr.h"
using namespace std;



bool WorstUtiliPath::operator()(BlockSet bs1, BlockSet bs2)
{
    return bs1.calcNumUsed()<bs2.calcNumUsed();//zwroc o mniejszej liczbie zajetych slotow

        }



bool BetterHopPath::operator()(BlockSet bs1, BlockSet bs2) //do sortowanie lsof
{// return bs1.sqfactorFit()> bs2.sqfactorFit(); //dla lsosguare hop
              return bs1.factorFit() > bs2.factorFit(); // zwroc z wiekszym factorfit
       }





//------------dla klasy setMgr-----------------------------------------------//
void SetMgr::addSet(BlockSet bs)
{
    m_mgr.push_back(bs);
}

Block SetMgr::getElement(int idx, int i)
{
    return m_mgr[idx].getBlock(i);
}

vector<bool> SetMgr::getPathOfEl(int idx)
{
    return m_mgr[idx].pathBlockSet();
}

int SetMgr::getModulCalcPath()
{

    return m_mgr[0].getSetModul();
}

//vector<bool> SetMgr::fragmPathFirst()
//{
//    sort(m_mgr.begin(), m_mgr.begin() + m_mgr.size(), MoreFramgPath());
//
//    return m_mgr[0].pathBlockSet();
//}
//
//void SetMgr::orderByFragm()
//{
//    sort(m_mgr.begin(), m_mgr.begin() + m_mgr.size(), MoreFramgPath());
//}
//
//vector<bool> SetMgr::betterFitPath()
//{
//    sort(m_mgr.begin(), m_mgr.begin() + m_mgr.size(), BetterFitPath());
//    return m_mgr[0].pathBlockSet();
//}
//
//vector<bool> SetMgr::lessAvSizePath()
//{
//    sort(m_mgr.begin(), m_mgr.begin() + m_mgr.size(), LessAvPath());
//    return m_mgr[0].pathBlockSet();
//}
//
//vector<bool> SetMgr::lessAvReqBlockPath()
//{
//    sort(m_mgr.begin(), m_mgr.begin() + m_mgr.size(), LessAvReqPath());
//    return m_mgr[0].pathBlockSet();
//}
//
//vector<bool> SetMgr::meanPath()
//{
//    sort(m_mgr.begin(), m_mgr.begin() + m_mgr.size(), MeanSize());
//    return m_mgr[0].pathBlockSet();
//}
//
//vector<bool> SetMgr::meanReqPath()
//{
//    sort(m_mgr.begin(), m_mgr.begin() + m_mgr.size(), MeanReqSize());
//    return m_mgr[0].pathBlockSet();
//}


///-------------------------//
vector<bool> SetMgr::worstPath()
{
    sort(m_mgr.begin(), m_mgr.begin() + m_mgr.size(), WorstUtiliPath());
    return m_mgr[0].pathBlockSet();
}
int SetMgr::getModulWorstPath() //popranie modulacji sciezki worstUtil
{
    sort(m_mgr.begin(), m_mgr.begin() + m_mgr.size(), WorstUtiliPath());
    return m_mgr[0].getSetModul();
}


vector<bool> SetMgr::betterFitHopPath() //sciezka lsoHop
{
    sort(m_mgr.begin(), m_mgr.begin() + m_mgr.size(), BetterHopPath());
    return m_mgr[0].pathBlockSet();
}

int SetMgr::getModLSoHopF() //pobranie modulacji sciezki LSoHop
{
    sort(m_mgr.begin(), m_mgr.begin() + m_mgr.size(), BetterHopPath());
    return m_mgr[0].getSetModul();
}



int SetMgr::sizeSetMgr()
{
    return m_mgr.size();
}

void SetMgr::dispalySetMgr()
{
    for (int i = 0; i < m_mgr.size(); ++i)
    {

        //m_mgr[i].displaySet();
        //cout<< endl;
        cout << " max idx: numUsed: utlitiz: " << m_mgr[i].calcMaxIdx() << " " << m_mgr[i].calcNumUsed() << " "
                << m_mgr[i].calcUtilize() << endl;
        cout << " modul numBlock allBlocks " << m_mgr[i].getSetModul() << " " << m_mgr[i].sizeSet() << " "
                << m_mgr[i].allBlocks() << endl;
        cout << " avsizeBlock " << m_mgr[i].avSizeAllBlocks() << endl;
        cout << " idx best, best size " << m_mgr[i].bestFirst() << " " << m_mgr[i].sizeBest() << endl;
        cout << " idx first, first size " << m_mgr[i].firstBlock() << " " << m_mgr[i].sizeFirst() << endl;
    }
}



BlockSet SetMgr::getBlockSet(int idx)
{
    return m_mgr[idx];
}









//bool MoreFramgPath::operator()(BlockSet bs1, BlockSet bs2) //two group block
//{
//   //wybor sciezkit tylko o wiekszej liczbie blokow ktore pomieszcza a nastepnie z mniejsza liczba hopow
//        if (bs1.sizeSet() == bs2.sizeSet()) //ilosci blokow , w ktore mozna pomiescic zadanie (nie wazna jest ich wielkosc, tylko to, ze pomieszcze ) jest taka sama ,to porownaj liczbe , w ktore nie mozna npchnac
//        {
//            return bs1.hopSet() < bs2.hopSet();
//
//
//        }
//            return bs1.sizeSet() > bs2.sizeSet(); //zwroc z wieksza liczba elemntow
//    }
//
////w zbiorze sciezek tej samej modulacji poszukiwana jest najlepiej pasujaca szczelina
//bool BetterFitPath::operator()(BlockSet bs1, BlockSet bs2)
//{
//
//        if (bs1.sizeBest() == bs2.sizeBest()) //kiedy maja takie same rozmiary blokow best fit to
//        {
//            return bs1.bestFirst() < bs2.bestFirst(); //zwroc best o mniejszym indeksie
//            //return bs1.hopSet() < bs2.hopSet();//nietestowane
//        }
//        return bs1.sizeBest() < bs2.sizeBest(); //im mniejszy rozmiar best fit tym bardziej bardziej dopasowane do zadania
//
//}
//
//
//bool LessAvPath::operator()(BlockSet bs1, BlockSet bs2)
//{
//
//        if (bs1.avSizeAllBlocks() == bs2.avSizeAllBlocks())
//        {
//
//                return bs1.hopSet() < bs2.hopSet();
//        }
//    return bs1.avSizeAllBlocks() < bs2.avSizeAllBlocks(); //zwroc sciezke z wieksza wartoscia avSizeAllBlocka, czyli zeby sciezke lepiej dopasowac do zadania
//
//}
//
//bool LessAvReqPath::operator()(BlockSet bs1, BlockSet bs2)
//{
//
//        if ( bs1.avBlockForReq() == bs2.avBlockForReq())
//        {
//            return bs1.hopSet() < bs2.hopSet();
//        }
//            return bs1.avBlockForReq() > bs2.avBlockForReq(); //zwroc sciezke o wiekszej wartosci wartoscia av block FOR req
//        }
//
//
//bool MeanSize::operator()(BlockSet bs1, BlockSet bs2)
//{
//
//        if (bs1.meanAllBlocks() ==bs2.meanAllBlocks())
//        {
//            return bs1.hopSet() < bs2.hopSet();
//        }
//            return bs1.meanAllBlocks() < bs2.meanAllBlocks(); //zwroc sciezke z mniejsza wartoscia mean block FOR req
//        }
//
//bool MeanReqSize::operator()(BlockSet bs1, BlockSet bs2)
//{
//
//        if (bs1.meanForReq() == bs2.meanForReq())
//        {
//             return bs1.hopSet() < bs2.hopSet();
//        }
//            return bs1.meanForReq() < bs2.meanForReq(); //zwroc sciezke z mniejsza wartoscia mean block FOR req
//        }
//
//
