#ifndef _SBVTNODE_H_
#define _SBVTNODE_H_

#include "glNaglowek.h"

#include <iostream>

using namespace std;

/*class SBVTnode{
public:
    int m_idxNode;
    double m_trans;//aktualna wartosc obciazenia
double m_maxCapacity;

SBVTnode();
    void initSBVTnode(int idxNode, double degree, double capacity);
    void setMaxCapacity( double degree, double capacity); //ustawienie max capacity dla wezla zlozonego z kilku ( tyle ile laczy wej/wyj) sbvt
    //double getMaxCapacity(
    bool enoughtCapacity(double bw);
    void addTransmission (double bw);
    void dropTransmission(double bw);
    double usedCapacity();
    void showSBVT();

    virtual ~SBVTnode();
 };*/

class SBVTransp
{
public:
    double m_transSBVT;//aktualna wartosc obciazenia
double m_maxCapacitySBVT;
double m_granularitySBVT;
vector<double> m_vecTransId;

SBVTransp();
void setSBVTransp(double maxCapacity, double granularity);//aktualna wartosc obciazenia
bool emptyTransp();
bool allocatedSBVTranp(double rate);
bool existTransId(int id);
void addTransId(double rate,int id);
void removeTransId(double rate,int id);
bool terminateTransId(double rate,int id);
double get_transSBVTransp();
void showSBVTransp();
~SBVTransp();
};


class SBVTnode{
public:
    int m_idxNode;
        //double m_trans;//aktualna wartosc obciazenia
double m_maxCapacity;
double m_granularity;
int m_nSBVTransp;
vector<SBVTransp> m_vecSBVTransp;

SBVTnode();
    void initSBVTnode(int idxNode, double degree, double capacity,double granularity,int numberSBVTransp);
    void setMaxCapacity( double degree, double capacity); //ustawienie max capacity dla wezla zlozonego z kilku ( tyle ile laczy wej/wyj) sbvt
    //double getMaxCapacity(
    bool enoughtCapacity(double bw);
    void addTransmission (double bw, int id);
    void dropTransmission(double bw, int id);
    int numSBVTransp();
    double usedCapacity();
    double ratioUtilizeSBVTnode();//aktulana wartosc transmisji/(l.transpond*maxCapacity)
    void showSBVT();

    ~SBVTnode();
 };

#endif
