#include "Net.h"

using namespace std;
vector<vector<vector<PathSD> > > Net::setRegFromFile(string filename, int node,
        int link, int can) {

    ifstream infile;
    infile.open(filename.c_str(), ios::in);
    if (infile.is_open() == false) {
        cerr << "nie mozna otworzyc pliku" << endl;
        abort();
    }

    vector<vector<vector<PathSD> > > tmp1; //wektor wszystkich sciezek zawartych w pliku
    vector<PathSD> ptmp; //wektor pomocniczy
    bool val;
    ptmp.clear();
    vector<bool> vecp;
    vecp.clear();
    m_connection.resize(node);
    tmp1.resize(node);
    for (int i = 0; i < node; ++i) {
        m_connection[i].resize(node);
        tmp1[i].resize(node);
        for (int j = 0; j < node; ++j) {
            if (i != j) //jezeli src!=drst to utworz dla takiej pary wektor, ktory przechowuje sciezki
                    {
                tmp1[i][j].resize(can); // ten wektor wektorow <bool> przechowuje wszystkie sciezki dla danego zadania SD
                ptmp.resize(can);
                for (int k = 0; k < can; ++k) {

                    vecp.clear();
                    vecp.resize(link);
                    PathSD p1;
                    for (int l = 0; l < link; ++l) //liczba kolumn
                            {
                        infile >> val;
                        if (infile.eof() == true) {
                            cerr << "???";
                            exit(1);
                        }

                        vecp[l] = val;
                    }
                    p1.setPath(vecp);
                    p1.setRegModul(m_links);
                    ptmp[k] = p1;
                }
                tmp1[i][j] = ptmp;

              ptmp.erase(ptmp.begin() + m_cand, ptmp.end());

                m_connection[i][j] = ptmp;

            }

        }


    }

    infile.close();
    //return tmp1;
    return m_connection;
}
