#ifndef _BLOCK_H_
#define _BLOCK_H_
#include "glNaglowek.h"
#include "PathSD.h"
using namespace std;

class Block //wolny blok slot�w nalezacy do danej ciezki
{
public:
	int m_idxStart;
	int m_size;
	int m_usageB; //wykorzystanie bloku na podstawie stanu sieci
	int m_numFree;//ilosc wolnych slotow na podstawie stanu sieci
	int m_head;//odleglosc przod
	int m_tail;
	vector<bool> m_path;
	int  m_mod;//modulacja sciezki

	Block ();
	Block (int idxStart,int size);
	//Block(int idxStart, int size, vector<bool> path);
	Block(int idxStart, int size, vector<bool> path,int m);
	Block (int idxStart, int size, int usageB, int numFree, vector<bool>path, int m);
	//Block (Block &src);

	void setUsageB(int usageB);
	void setNumFree(int numFree);
	void setHead(int head);
	void setTail(int tail);
	void setBlockModul(int m);

	int	blockModul();
	int sizeB();
	int idx();
	int idxEnd();
	int usageB();
	int numFreeB();
	int headB();
	int tailB();
	int sumHeadTail(); //zwraca sume ogona i glowy niedopasowania
	int minEdge(); //zwraca wartosc mniejszego niedopasowania

	int edgeAlloc(int numReq); //zwraca start lepszego niedopasowania w zadanym bloku

	vector<bool> blockPath();
	int hopBlock(); //liczba hopow sciezki bloku

	//------------------//
	void displayBlock();

	void incrSize();//zwieksz rozmiar , potrzebne przy usatwianiu wektora blokow
	bool isEnought(int numReq);
	bool isBest(int numReq);
	bool operator < (const Block &b)const;

	//------------------//
	void calParam(vector<vector<int > > netU);//obliczenia dotycza wykorzystania bloku w sieci, czyli na wszystkich �aczach

	int calcHeadBlock(vector<int >  pathLink);
	int calcTailBlock(vector<int >  pathLink);

	virtual ~Block();

};
#endif
