 #ifndef _FITGAP_H_
#define _FITGAP_H_
#include "glNaglowek.h"
#include "Block.h"
#include "BlockSet.h"

//dopisac alg wykorzystujacy MoreUsageOnly
class LessFreeMoreUsage{
public:
	bool operator()(Block b1, Block b2);
};
 class MoreUsageOnly{
 public:
	 bool operator ()(Block b1, Block b2);
 };

class BetterEdge{
public:
	bool operator()(Block b1, Block b2);
};

class FitGap //dopasowanie z prawej i lewej strony
{
public:
	vector<Block> m_gaps;
	vector<bool> pathSD;
	FitGap();

	void fitGapForReq(vector<bool> path, int numReq, vector<int> sumFiber, int modul); //dopasuj szczeliny do dania, w ten sposb jesli nie isnieje best fit to bloki s dzielone na lewy i prawy

	void setEdgeFitGap( int idx, int numToStart, int numToEnd);//ustaw glowe i ogon dla fit gap
	void paramUsage(int idx, int usage, int free);//ustaw usage, numFree
	int gapSize();//ilosc elemntow fitGAp
	int gapStart(int idx); //zwroc indeks startu dla bloku pod indeksem idx
	//bool existFreeInFitGap(); //czy isnieja niewykorzytane w jakimkoliwek bloku FitGap

	int maxUsageFitGap();//sortowanie minFree, max usage
	int edgeFitGap() ;//zwraca indeks najmniejszego niedopasowania na czach
	void displayFitGap();

};
#endif
