/*
 * PathSD.cc
 *
 *  Created on: 08-09-2014
 *      Author: Edyta
 */

#include "PathSD.h"

using namespace std;

PathSD::PathSD() {
}

void PathSD::setPath(vector<bool> path) {
    m_path = path;
    int hopCounter = 0;
    for (int i = 0; i < m_path.size(); ++i) {
        if (m_path[i] > 0) {
            hopCounter++;
        }
    }
    m_hop = hopCounter;

}
void PathSD::setLengthModul(vector<int> links) {
    int len = 0;
    for (int i = 0; i < m_path.size(); ++i) {
        len += m_path[i] * links[i];
    }
    m_length = len;

    if (len <= 1200) //dlugosc sciezki modulacja dla BW slotu=12.5 GHz
            {
        m_mod = 4; // 16-QAM
    }

    if (len <= 2400 && len > 1200) {
        m_mod = 3; //8-QAM
    }

    if (len <= 4800 && len > 2400) {
        m_mod = 2; //QPSK
    }

    if (len > 4800 && len <= 9600) {
        m_mod = 1; //BPSK
    }
    /* if (len>9600)
     {
     cerr<< "two long path "<<endl;
     //exit(1);
     }*/

}

void PathSD::setRegModul(vector<int> links )
{
    if(m_path.size()!=links.size())

    {
    cerr << "rozne wektory scieka i links PathSD "<<endl;
    exit(1);
    }

    int maxLenLink=0;
    for(int i=0; i<m_path.size(); ++i)
    {

            if (m_path[i]==1)
            {
                if(maxLenLink<links[i])
            {
                maxLenLink=links[i];
                }
    }
    }
    if( maxLenLink<=1200) // modulacja dla BW slotu=12.5 GHz
               {
                   m_mod= 4;//16-QAM
                   //cout<< " modul po regeneracji= "<< m_mod<< " " ;

               }

       if (maxLenLink<= 2400 && maxLenLink > 1200) {

                   m_mod= 3;//8-QAM
                   //cout<< " modul po regeneracji= "<< m_mod<< " " ;

               }

               if (maxLenLink<= 4800 && maxLenLink > 2400) {
                   m_mod=2;//QPSK

               }

                if (maxLenLink > 4800 && maxLenLink <= 9600) {
                m_mod=1; //BPSK
               }
               if (maxLenLink>9600)
               {
                    m_mod = -1;
                // cerr << "two long link after regeneration "<<endl;
               //exit(1);
                }

       }



int PathSD::getHops() {
    return m_hop;
}
int PathSD::getLength() {
    return m_length;
}
int PathSD::getModul() {
    return m_mod;
}
vector<bool> PathSD::getVec() {
    return m_path;
}

//-----------------------------------------------------------

PathSD::~PathSD() {
}
