#include "Net.h"

using namespace std;
vector<double> Net:: loadDegreeNodeFromFile(string filename, int nodes,
        int links) {

    vector<double> tmpDegree;
    tmpDegree.resize(nodes);
    vector<vector<int> > topology;

    ifstream infile(filename.c_str());
    if (infile.is_open() == false) {
        cerr << "Error: Unable to read the specified network structure file."
                << endl;
        exit(1);
    }

    topology.resize(nodes);

    for (int i = 0; i < nodes; ++i) {
        topology[i].resize(nodes);

        for (int j = 0; j < nodes; ++j) {

            if (infile.eof() == true) {
                cerr << "Error: Insufficient number of coefficients." << endl;
                exit(1);
            }
            infile >> topology[i][j];
        }
    }
    infile.close();
     double tmp;
    // Fill the vector of distance values
    for (int i = 0; i < nodes; ++i) {
        tmp=0;

        for (int j = 0; j < nodes; ++j) {
            if (topology[i][j] > 0) {
                tmp++;
               // cout<< "dlugosc: "<<topology[i][j];

            }
            //cout<<tmp<<endl;
tmpDegree[i]=tmp;
        }

    }
/*for(int i=0; i<nodes;++i)
{ if(tmpDegree[i]==4)
{ cout<< "indeks wezla: " <<i<<" stopien wezla: " <<tmpDegree[i]<<endl;}
}*/
    return tmpDegree;
}
